# coding=utf-8
# --------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for
# license information.
#
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

from msrest.serialization import Model


class CheckNameAvailabilityResult(Model):
    """
    The CheckNameAvailability operation response.

    :param bool name_available: Gets a boolean value that indicates whether
     the name is available for you to use. If true, the name is available. If
     false, the name has already been taken or invalid and cannot be used.
    :param str reason: Gets the reason that a storage account name could not
     be used. The Reason element is only returned if NameAvailable is false.
     Possible values include: 'AccountNameInvalid', 'AlreadyExists'
    :param str message: Gets an error message explaining the Reason value in
     more detail.
    """

    _required = []

    _attribute_map = {
        'name_available': {'key': 'nameAvailable', 'type': 'bool'},
        'reason': {'key': 'reason', 'type': 'Reason'},
        'message': {'key': 'message', 'type': 'str'},
    }

    def __init__(self, *args, **kwargs):
        self.name_available = None
        self.reason = None
        self.message = None

        super(CheckNameAvailabilityResult, self).__init__(*args, **kwargs)
