# coding=utf-8
# --------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for
# license information.
#
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

from .resource import Resource


class StorageAccountUpdateParameters(Resource):
    """
    The parameters to update on the account.

    :param str account_type: Gets or sets the account type. Note that
     StandardZRS and PremiumLRS accounts cannot be changed to other account
     types, and other account types cannot be changed to StandardZRS or
     PremiumLRS. Possible values include: 'Standard_LRS', 'Standard_ZRS',
     'Standard_GRS', 'Standard_RAGRS', 'Premium_LRS'
    :param CustomDomain custom_domain: User domain assigned to the storage
     account. Name is the CNAME source. Only one custom domain is supported
     per storage account at this time. To clear the existing custom domain,
     use an empty string for the custom domain name property.
    """

    _required = []

    _attribute_map = {
        'account_type': {'key': 'properties.accountType', 'type': 'AccountType'},
        'custom_domain': {'key': 'properties.customDomain', 'type': 'CustomDomain'},
    }

    def __init__(self, *args, **kwargs):
        self.account_type = None
        self.custom_domain = None

        super(StorageAccountUpdateParameters, self).__init__(*args, **kwargs)
